/* CCaMeter Installation */
'@Echo Off'
Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
Call SysLoadFuncs
Signal On Failure Name FAILURE
Signal On Halt Name HALT
Signal On Syntax Name SYNTAX
Call SysCls
Say 'Central Coast Associates Installation'
Say 'Installing CPU Meter'
Say ''
Result = SysFileTree( 'CCAMETER.EXE', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERROR: CCAMETER.EXE not found! Installation cancelled.'
  Signal DONE
  End
Result = SysFileTree( 'README.TXT', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERROR: README.TXT not found! Installation cancelled.'
  Signal DONE
  End
Result = SysFileTree( 'LICENSE.TXT', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERROR: LICENSE.TXT not found! Installation cancelled.'
  Signal DONE
  End
Result = SysFileTree( 'REGISTER.TXT', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERROR: REGISTER.TXT not found! Installation cancelled.'
  Signal DONE
  End
Result = SysFileTree( 'INSTALL.CMD', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERROR: INSTALL.CMD not found! Installation cancelled.'
  Signal DONE
  End
Say 'Please enter Path of directory files '
Say '(default C:\CCAMETER): '
Pull Directory
If Directory = "" Then Directory = 'C:\CCAMETER'
Result = SysFileTree( Directory, 'Dirs', 'D' )
If Dirs.0 = 0 Then
  Do
  Result = SysMkDir( Directory )
  if Result == 0 Then
    Do
    End
  Else
    Do
    Say Result ' ERROR: Create target directory. Installation cancelled.'
    Signal DONE
    End
  End
Say ''
Say 'Copying CCAMETER.EXE to' Directory '...'
Copy CCAMETER.EXE Directory                  '1>NUL'
Say 'Copying README.TXT to' Directory '...'
Copy README.TXT Directory                  '1>NUL'
Say 'Copying LICENSE.TXT to' Directory '...'
Copy LICENSE.TXT Directory                  '1>NUL'
Say 'Copying REGISTER.TXT to' Directory '...'
Copy REGISTER.TXT Directory                  '1>NUL'
Say 'Copying INSTALL.CMD to' Directory '...'
Copy INSTALL.CMD Directory                  '1>NUL'
Say ''
Say 'Creating program object...'
Say ''
Type = 'WPProgram'
Title = 'CCaMeter'
Folder = '<WP_DESKTOP>'
Parms = 'MINWIN=DESKTOP;PROGTYPE=PM;EXENAME='Directory'\CCAMETER.EXE;PARAMETERS=-;STARTUPDIR='Directory';OBJECTID=<CCAMETER>;NOPRINT=YES;'
Result = SysCreateObject( Type, Title, Folder, Parms, 'ReplaceIfExists' )
If Result = 1 Then
  Say 'CCaMeter was successfully installed.'
  Exit
Else
  Say 'ERROR: Unable to create DeskTop Program Object.'
  Exit

FAILURE:
Say 'Installation error.'
Signal DONE
HALT:
Say 'Installation error.'
Signal DONE
SYNTAX:
Say 'Installation error.'
Signal DONE
DONE:
Exit
