/*

   ScanPoll.rexx 1.2

   Lets you select one or more of the files in your Outbound directory and
   call the systems the files are destined for using TrapDispatcher

   Requires RequestFile in C:

   History:

   1.1   You can now select multiple files
   1.2   Now uses the option REQ so that requesters are shown when a
         node can't be called for some reason. Requires TrapDispatcher 1.1.

*/

/* Change these to suit your system */

pubscreen="TRAPDOOR"
dispatchport="TRAPDISPATCHER"
outbound="MAIL:Outbound"

/* Real script starts here */

options results

IF ~SHOW(Libraries,'rexxsupport.library') THEN
    IF ~ADDLIB("rexxsupport.library",0,-30,0) THEN EXIT

address command 'RequestFile MULTISELECT TITLE "Choose file" DRAWER "'outbound'" PUBSCREEN "'pubscreen'" PATTERN "#?.(REQ|?LO|?UT)" >t:reqtmp'

/* No file selected */

if rc=5 then do
 call delete('t:reqtmp')
 exit
end

/* Get selected file */

call open('file','t:reqtmp','R')
buf=readln('file')
call close('file')
call delete('t:reqtmp')

parse var buf '"'filename'"'buf

do while filename~=""
 /* Get rid of path */

 while lastpos(':',filename)~=0
    filename=right(filename,length(filename)-lastpos(':',filename))

 while lastpos('/',filename)~=0
    filename=right(filename,length(filename)-lastpos('/',filename))

 /* Make FidoNet address */

 parse var filename zone"."net"."node"."point"."
 addr=zone":"net"/"node"."point

 address value dispatchport
 'call 'addr' REQ'

 parse var buf '"'filename'"'buf
end

