// Developer Helper Object Set, (C) 1994 Thomas E. Bednarz, Jr.
//  All rights reserved


#ifndef __WINBASE_H__
#define __WINBASE_H__

#define INCL_PM
#define INCL_WIN
#define INCL_GPI
#include <os2.h>             
#include"object.h"


const ULONG WinBase_NoResource = 0;


class TWinBase : public TObject
{
 
   protected:
     HWND hwndFrame;
     ULONG fResource;

      HPS getScreenPS();
   public:
      TWinBase(ULONG resource);
      virtual ~TWinBase(void);
      virtual BOOL Init(HAB hab)=0;
      virtual const char *getClassName(void);
      HWND getFrame(void);
      virtual BOOL MakeFrame(void)=0;
      virtual MRESULT doCommand(HWND hWnd, ULONG Message, MPARAM mParam1, MPARAM mParam2)=0;

      BOOL isEnabled();
      BOOL enableUpdate(BOOL enable);
      BOOL isVisible();

      virtual BOOL setParent(TWinBase *parent, BOOL redraw);
      BOOL isChild(TWinBase *parent);
 
      void setWindowPosition(LONG x, LONG y, LONG cx, LONG cy, ULONG fl);
      void getWindowPosition(LONG &x, LONG &y, LONG &cx, LONG &cy);

      void Update();
 
};


#endif  //winbase
